OpenSubdiv: GLPatchTable Class Reference

| OpenSubdiv

Loading...
Searching...
No Matches
GLPatchTable Class Reference

`#include <glPatchTable.h>`

Inheritance diagram for GLPatchTable:

## Public Types
using | ID = unsigned int
using | VertexBufferBinding = ID

## Public Member Functions
| ~GLPatchTable ()
PatchArrayVector const & | GetPatchArrays () const
| Returns the patch arrays for vertex index buffer data.
ID | GetPatchIndexBuffer () const
| Returns the GL index buffer containing the patch control vertices.
ID | GetPatchParamBuffer () const
| Returns the GL index buffer containing the patch parameter.
ID | GetPatchIndexTextureBuffer () const
| Returns the GL texture buffer containing the patch control vertices.
ID | GetPatchParamTextureBuffer () const
| Returns the GL texture buffer containing the patch parameter.
PatchArrayVector const & | GetVaryingPatchArrays () const
| Returns the patch arrays for varying index buffer data.
ID | GetVaryingPatchIndexBuffer () const
| Returns the GL index buffer containing the varying control vertices.
ID | GetVaryingPatchIndexTextureBuffer () const
| Returns the GL texture buffer containing the varying control vertices.
int | GetNumFVarChannels () const
| Returns the number of face-varying channel buffers.
PatchArrayVector const & | GetFVarPatchArrays (int fvarChannel=0) const
| Returns the patch arrays for face-varying index buffer data.
ID | GetFVarPatchIndexBuffer (int fvarChannel=0) const
| Returns the GL index buffer containing face-varying control vertices.
ID | GetFVarPatchIndexTextureBuffer (int fvarChannel=0) const
| Returns the GL texture buffer containing face-varying control vertices.
ID | GetFVarPatchParamBuffer (int fvarChannel=0) const
| Returns the GL index buffer containing face-varying patch params.
ID | GetFVarPatchParamTextureBuffer (int fvarChannel=0) const
| Returns the GL texture buffer containing face-varying patch params.

## Static Public Member Functions
static GLPatchTable * | Create (Far::PatchTable const *farPatchTable, void *deviceContext=NULL)

## Protected Member Functions
| GLPatchTable ()
bool | allocate (Far::PatchTable const *farPatchTable)

## Protected Attributes
PatchArrayVector | _patchArrays
ID | _patchIndexBuffer
ID | _patchParamBuffer
ID | _patchIndexTexture
ID | _patchParamTexture
PatchArrayVector | _varyingPatchArrays
ID | _varyingIndexBuffer
ID | _varyingIndexTexture
std::vector< PatchArrayVector > | _fvarPatchArrays
std::vector< ID > | _fvarIndexBuffers
std::vector< ID > | _fvarIndexTextures
std::vector< ID > | _fvarParamBuffers
std::vector< ID > | _fvarParamTextures

## Detailed Description

Definition at line 27 of file glPatchTable.h.

## Member Typedef Documentation

## ◆ ID

using ID = unsigned int

Definition at line 29 of file glPatchTable.h.

## ◆ VertexBufferBinding

using VertexBufferBinding = ID

Definition at line 30 of file glPatchTable.h.

## Constructor & Destructor Documentation

## ◆ ~GLPatchTable()

~GLPatchTable | ( |  | ) |

## ◆ GLPatchTable()

GLPatchTable | ( |  | ) |
| protected

## Member Function Documentation

## ◆ allocate()

bool allocate | ( | Far::PatchTable const * | farPatchTable | ) |
| protected

## ◆ Create()

GLPatchTable * Create | ( | Far::PatchTable const * | farPatchTable,
|  | void * | deviceContext = NULL )
| static

## ◆ GetFVarPatchArrays()

PatchArrayVector const & GetFVarPatchArrays | ( | int | fvarChannel = 0 | ) | const
| inline

Returns the patch arrays for face-varying index buffer data.

Definition at line 81 of file glPatchTable.h.

## ◆ GetFVarPatchIndexBuffer()

ID GetFVarPatchIndexBuffer | ( | int | fvarChannel = 0 | ) | const
| inline

Returns the GL index buffer containing face-varying control vertices.

Definition at line 86 of file glPatchTable.h.

## ◆ GetFVarPatchIndexTextureBuffer()

ID GetFVarPatchIndexTextureBuffer | ( | int | fvarChannel = 0 | ) | const
| inline

Returns the GL texture buffer containing face-varying control vertices.

Definition at line 91 of file glPatchTable.h.

## ◆ GetFVarPatchParamBuffer()

ID GetFVarPatchParamBuffer | ( | int | fvarChannel = 0 | ) | const
| inline

Returns the GL index buffer containing face-varying patch params.

Definition at line 96 of file glPatchTable.h.

## ◆ GetFVarPatchParamTextureBuffer()

ID GetFVarPatchParamTextureBuffer | ( | int | fvarChannel = 0 | ) | const
| inline

Returns the GL texture buffer containing face-varying patch params.

Definition at line 101 of file glPatchTable.h.

## ◆ GetNumFVarChannels()

int GetNumFVarChannels | ( |  | ) | const
| inline

Returns the number of face-varying channel buffers.

Definition at line 78 of file glPatchTable.h.

## ◆ GetPatchArrays()

PatchArrayVector const & GetPatchArrays | ( |  | ) | const
| inline

Returns the patch arrays for vertex index buffer data.

Definition at line 38 of file glPatchTable.h.

## ◆ GetPatchIndexBuffer()

ID GetPatchIndexBuffer | ( |  | ) | const
| inline

Returns the GL index buffer containing the patch control vertices.

Definition at line 43 of file glPatchTable.h.

## ◆ GetPatchIndexTextureBuffer()

ID GetPatchIndexTextureBuffer | ( |  | ) | const
| inline

Returns the GL texture buffer containing the patch control vertices.

Definition at line 53 of file glPatchTable.h.

## ◆ GetPatchParamBuffer()

ID GetPatchParamBuffer | ( |  | ) | const
| inline

Returns the GL index buffer containing the patch parameter.

Definition at line 48 of file glPatchTable.h.

## ◆ GetPatchParamTextureBuffer()

ID GetPatchParamTextureBuffer | ( |  | ) | const
| inline

Returns the GL texture buffer containing the patch parameter.

Definition at line 58 of file glPatchTable.h.

## ◆ GetVaryingPatchArrays()

PatchArrayVector const & GetVaryingPatchArrays | ( |  | ) | const
| inline

Returns the patch arrays for varying index buffer data.

Definition at line 63 of file glPatchTable.h.

## ◆ GetVaryingPatchIndexBuffer()

ID GetVaryingPatchIndexBuffer | ( |  | ) | const
| inline

Returns the GL index buffer containing the varying control vertices.

Definition at line 68 of file glPatchTable.h.

## ◆ GetVaryingPatchIndexTextureBuffer()

ID GetVaryingPatchIndexTextureBuffer | ( |  | ) | const
| inline

Returns the GL texture buffer containing the varying control vertices.

Definition at line 73 of file glPatchTable.h.

## Member Data Documentation

## ◆ _fvarIndexBuffers

std::vector<ID> _fvarIndexBuffers
| protected

Definition at line 124 of file glPatchTable.h.

## ◆ _fvarIndexTextures

std::vector<ID> _fvarIndexTextures
| protected

Definition at line 125 of file glPatchTable.h.

## ◆ _fvarParamBuffers

std::vector<ID> _fvarParamBuffers
| protected

Definition at line 127 of file glPatchTable.h.

## ◆ _fvarParamTextures

std::vector<ID> _fvarParamTextures
| protected

Definition at line 128 of file glPatchTable.h.

## ◆ _fvarPatchArrays

std::vector<PatchArrayVector> _fvarPatchArrays
| protected

Definition at line 123 of file glPatchTable.h.

## ◆ _patchArrays

PatchArrayVector _patchArrays
| protected

Definition at line 111 of file glPatchTable.h.

## ◆ _patchIndexBuffer

ID _patchIndexBuffer
| protected

Definition at line 113 of file glPatchTable.h.

## ◆ _patchIndexTexture

ID _patchIndexTexture
| protected

Definition at line 116 of file glPatchTable.h.

## ◆ _patchParamBuffer

ID _patchParamBuffer
| protected

Definition at line 114 of file glPatchTable.h.

## ◆ _patchParamTexture

ID _patchParamTexture
| protected

Definition at line 117 of file glPatchTable.h.

## ◆ _varyingIndexBuffer

ID _varyingIndexBuffer
| protected

Definition at line 120 of file glPatchTable.h.

## ◆ _varyingIndexTexture

ID _varyingIndexTexture
| protected

Definition at line 121 of file glPatchTable.h.

## ◆ _varyingPatchArrays

PatchArrayVector _varyingPatchArrays
| protected

Definition at line 119 of file glPatchTable.h.

The documentation for this class was generated from the following file:

- opensubdiv/osd/glPatchTable.h